]> git.draconx.ca Git - cdecl99.git/blobdiff - tests/stress.at
Port to use getline.h from dxcommon.
[cdecl99.git] / tests / stress.at
index 9bc84cf5e76693a431487e0d5722ead4d3fe4a84..a8e95003ac93e380f55dce18bc49321e7bd1ecd0 100644 (file)
@@ -1,4 +1,4 @@
-# Copyright © 2012, 2020, 2022-2023 Nick Bowler
+# Copyright © 2012, 2020, 2022-2024 Nick Bowler
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <https://www.gnu.org/licenses/>.
 
-AT_BANNER([Randomized tests])
+AT_BANNER([Stress tests])
 
 dnl Verify the RNG implementation
-AT_SETUP([xoshiro256p sanity])
-
-TEST_NEED_PROGRAM([rng-test])
-AT_CHECK([rng-test >out
-grep -v '^ok' out], [0], [1..200
-])
-
-AT_CLEANUP
+TEST_TAP_SIMPLE([xoshiro256p sanity], [rng-test],
+  [TEST_NEED_PROGRAM([rng-test])])
 
 dnl Verify that randomdecl actually produces all keywords and a variety
 dnl of different declarations.
@@ -36,8 +30,8 @@ m4_define([sanity_tests], [dnl
   [[^type], [type name]],
   [[inline], [inline function specifier]],
   [[inline inline], [redundant function specifiers]],
-  [[function (@<:@RE_ALNUM()_@:>@* as], [named function parameter]],
-  [[function (void)], [empty prototype declaration]],
+  [[function [(]@<:@]]RE_ALNUM()_[[@:>@* as], [named function parameter]],
+  [[function [(]void[)]], [empty prototype declaration]],
   [[function returning], [non-prototype function declaration]],
   [[\.\.\.], [variadic function]],
   [[const], [const qualifier]],
@@ -68,24 +62,89 @@ m4_define([sanity_tests], [dnl
   [[pointer to function], [pointer to a function]],
 ])
 
-m4_define([sanity_sed], [/$1/i\
-FOUND $2])AT_DATA([sanity.sed], [#n
-m4_map_sep([sanity_sed], [m4_newline], [sanity_tests])
+m4_define([sanity_awk], [[/$1/ { found["$2"] = 1; }
+]])AT_DATA([sanity.awk],
+[# We don't need any field splitting, so choose a character that does not
+# appear in C code to avoid tripping over 199-field limit in HP-UX 11 awk.
+BEGIN { FS = "@"; }
+m4_map([sanity_awk], [sanity_tests])dnl
+END { for (k in found) print "FOUND", k; }
 ])
-sed -n '/^FOUND/p' sanity.sed | LC_ALL=C sort -u >expout
 
-printf 'Using seed %d\n' "$random_seed" >&AS_MESSAGE_LOG_FD
+m4_define([sanity_exp], [[FOUND $2
+]])
+LC_ALL=C sort >expout <<'EOF'
+m4_map([sanity_exp], [sanity_tests])dnl
+EOF
+
+AS_ECHO(["Using seed $random_seed"]) >&AS_MESSAGE_LOG_FD
 AT_CHECK([randomdecl -En 10000 -s "$random_seed" >decls], [0])
-AT_CHECK([sed -f sanity.sed decls | LC_ALL=C sort -u], [0], [expout])
+AT_CHECK([$AWK -f sanity.awk decls | LC_ALL=C sort], [0], [expout])
 
 AT_CLEANUP
 
-AT_SETUP([random cross-parse])
+AT_SETUP([Random crossparse])
 
 TEST_NEED_PROGRAM([randomdecl])
 TEST_NEED_PROGRAM([crossparse])
 
-printf 'Using seed %d\n' "$random_seed" >&AS_MESSAGE_LOG_FD
+AS_ECHO(["Using seed $random_seed"]) >&AS_MESSAGE_LOG_FD
 AT_CHECK([randomdecl -n "$random_iter" -s "$random_seed"],, [stdout-nolog])
 AT_CHECK([crossparse -f stdout])
 AT_CLEANUP
+
+# Check that we can parse declarations with more than 10000 specifiers.
+AT_SETUP([Excessive specifiers])
+
+AT_CHECK([gunzip -c "$srcdir/tests/data/manyspec.gz" >test.dat || exit 77
+cdecl99 -f test.dat], [0],
+[[type const int
+type const int
+const int
+const int
+inline int f()
+]])
+
+AT_CLEANUP
+
+# Check that we can parse declarations with more than 10000 declarators.
+AT_SETUP([Excessive declarators])
+
+AT_DATA([check.awk],
+[[# We don't need any field splitting, so choose a character that does not
+# appear in C code to avoid tripping over 199-field limit in HP-UX 11 awk.
+BEGIN { FS = "@"; runstart = 0; }
+END { finish_run(NR); }
+
+$0 != lastline {
+  finish_run(NR-1);
+  lastline = $0;
+  runstart = NR;
+  print;
+}
+
+function finish_run(nr) {
+  count = nr - runstart;
+  if (count > 0)
+    print "[repeated " count " more times]";
+}
+]])
+
+AT_CHECK([gunzip -c "$srcdir/tests/data/manydecl.gz" >test.dat || exit 77
+cdecl99 -f test.dat >test.out; status=$?;
+tr <test.out ',' '
+' | $AWK -f check.awk
+exit $status], [0],
+[[declare a as int
+[repeated 16383 more times]
+type function (a
+ a
+[repeated 16381 more times]
+ a) returning int
+int (a
+ a
+[repeated 16381 more times]
+ a)
+]])
+
+AT_CLEANUP